package com.marvinelsen.chinese.phonetics.internal.syllable.formatting

import com.marvinelsen.chinese.phonetics.Tone
import com.marvinelsen.chinese.phonetics.internal.syllable.Syllable
import com.marvinelsen.chinese.phonetics.internal.syllable.TranscriptionDataRepository
import com.marvinelsen.chinese.phonetics.toZhuyinTone

internal data object ZhuyinSyllableFormatter : SyllableFormatter {
    override fun format(syllable: Syllable): String {
        val zhuyinBase = TranscriptionDataRepository.pinyinToZhuyin[syllable.basePinyin]!!
        val zhuyinToneMark = syllable.tone.toZhuyinTone()

        return when (syllable.tone) {
            Tone.FIFTH -> zhuyinToneMark + zhuyinBase
            Tone.FIRST, Tone.SECOND, Tone.THIRD, Tone.FOURTH -> zhuyinBase + zhuyinToneMark
        }
    }
}
