package com.marvinelsen.chinese.phonetics.internal.syllable.parsing

import com.marvinelsen.chinese.phonetics.exceptions.InvalidSyllableInputException
import com.marvinelsen.chinese.phonetics.internal.syllable.Syllable

internal sealed interface SyllableParser {
    fun parseOrNull(input: String): Syllable?
    fun parse(input: String) = parseOrNull(input)
        ?: throw InvalidSyllableInputException("Invalid input for syllable parsing: '$input'")
}
