package com.marvinelsen.chinese.phonetics.internal.tone.parsing

import com.marvinelsen.chinese.phonetics.Tone
import com.marvinelsen.chinese.phonetics.exceptions.InvalidToneInputException

internal sealed interface ToneParser<T> {
    fun parseOrNull(input: T): Tone?
    fun parse(input: T) = parseOrNull(input)
        ?: throw InvalidToneInputException("Invalid input for tone parsing: '$input'")
}
